#include <windows.h>
#include <process.h>    /* _beginthread, _endthread */

#include "tinygraphics.h"

#define APP_NAME TEXT("Of[V낤\tNo2")
#define MUTEX_NAME TEXT("Mutex")

HDC hMemDC;
HDC hTextDC;
HWND hWnd;
HBITMAP hBitmap;
HBITMAP hTextmap;

HANDLE hMutex;
int psetFlag;

TEXTMETRIC textMetrics;

static void startup(void *dummy);

void clearText(void){
	Rectangle(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);

	InvalidateRect(hWnd , NULL , 0);
}

int myprintf(char *format){
	static unsigned int lines = 0;
//	PAINTSTRUCT ps;
//	HDC hdc;

	TabbedTextOut(hTextDC,0,0,APP_NAME,lstrlen(APP_NAME),0,NULL,0);
	TabbedTextOut(hTextDC,0,textMetrics.tmHeight,APP_NAME,lstrlen(APP_NAME),0,NULL,0);
	
/*	hdc = BeginPaint(hTextDC,&ps);*/
	BitBlt(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE-textMetrics.tmHeight,hTextDC,0,textMetrics.tmHeight,SRCCOPY);
/*	EndPaint(hWnd,&ps);*/

	return 0;
}

void pset(int x,int y,unsigned int r,unsigned int g,unsigned int b){
	HPEN hPen;
	HGDIOBJ hPObj;
#if PIXEL_SIZE > 2
	HBRUSH hBrush;
	HGDIOBJ hBObj;
#endif
	RECT rect;
/*
	if(0x80000000&r){
		r = 0;
	}else if(r>255){
		r = 255;
	}
	if(0x80000000&g){
		g = 0;
	}else if(g > 255){
		g = 255;
	}
	if(0x80000000&b){
		b = 0;
	}else if(b > 255){
		b = 255;
	}
	*/
	hPen = CreatePen(PS_SOLID,1,RGB(r&0xff,g&0xff,b&0xff));
	hPObj = SelectObject(hMemDC,hPen);
#if PIXEL_SIZE > 2
	hBrush = CreateSolidBrush(RGB(r&0xff,g&0xff,b&0xff));
	hBObj = SelectObject(hMemDC,hBrush);
#endif

	rect.left = PIXEL_SIZE*x;
	rect.top = PIXEL_SIZE*y;
	rect.right = rect.left+PIXEL_SIZE;
	rect.bottom = rect.top+PIXEL_SIZE;
//	Rectangle(hMemDC,PIXEL_SIZE*x,PIXEL_SIZE*y,PIXEL_SIZE*(x+1),PIXEL_SIZE*(y+1));
	
	WaitForSingleObject(hMutex,INFINITE);

#if PIXEL_SIZE > 1
	Rectangle(hMemDC,rect.left,rect.top,rect.right,rect.bottom);
#else
	SetPixel(hMemDC,x,y,RGB(r,g,b));
#endif

	ReleaseMutex(hMutex);

	SelectObject(hMemDC,hPObj);
	DeleteObject(hPen);
#if PIXEL_SIZE > 2
	SelectObject(hMemDC,hBObj);
	DeleteObject(hBrush);
#endif

	psetFlag = 1;
}

static void startup(void *dummy){
	main();
	InvalidateRect(hWnd , NULL , 0);
}

static void init(void){
	HDC hdc=GetDC(hWnd);

	/* foCXƃrbg}bv쐬 */
	hMemDC = CreateCompatibleDC(hdc);
	hBitmap  = CreateCompatibleBitmap(hdc,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
	hTextDC = CreateCompatibleDC(hdc);
	hTextmap = CreateCompatibleBitmap(hdc,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
	ReleaseDC(hWnd,hdc);

	/* yƃuV̐ݒ */
	SelectObject(hMemDC,hBitmap);
	SelectObject(hMemDC,GetStockObject(WHITE_PEN));
	SelectObject(hMemDC,GetStockObject(WHITE_BRUSH));

	SelectObject(hTextDC,hTextmap);
	SelectObject(hTextDC,GetStockObject(WHITE_PEN));
	SelectObject(hTextDC,GetStockObject(WHITE_BRUSH));

	/* foCXɒ`` */
	Rectangle(hMemDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
	Rectangle(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);

	/* tHg̐F̐ݒ */
	SetTextColor(hTextDC,RGB(0,0,0));
	GetTextMetrics(hTextDC,&textMetrics);

	/* MutexIuWFNg̐ */
	hMutex = CreateMutex(NULL,FALSE,MUTEX_NAME);
}

LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;

	switch(uMsg){
	case WM_DESTROY:
		/* foCXƃrbg}bv폜 */
		DeleteDC(hMemDC);
		DeleteObject(hBitmap);
		DeleteDC(hTextDC);
		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		init();

		//main();
		_beginthread(startup,0,NULL);

		return 0;

	case WM_MOUSEMOVE:
		/* foCXɓ_` */
		/*
		if(GetKeyState(VK_LBUTTON) <0){
			int x=LOWORD(lParam);
			int y=HIWORD(lParam);
			Ellipse(hMemDC,x-2,y-2,x+2,y+2);
			InvalidateRect(hWnd,NULL,FALSE);
		}
		*/
		return 0;

	case WM_PAINT:
		WaitForSingleObject(hMutex,INFINITE);
		hdc = BeginPaint(hWnd,&ps);
		/* OtBbNX]] */
		BitBlt(hdc,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE,hMemDC,0,0,SRCCOPY);
		/* eLXg] */
		BitBlt(hdc,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE,hTextDC,0,0,SRCAND);
		EndPaint(hWnd,&ps);
		ReleaseMutex(hMutex);
	
		return 0;

	default:
		if(psetFlag){
			psetFlag = 0;
			InvalidateRect(hWnd , NULL , 0);
		}
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,PSTR lpCmdLine,int nCmdShow){
	WNDCLASS wc;
	MSG msg;

	psetFlag = 0;

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = APP_NAME;
	
	if(!RegisterClass(&wc)){
		return 0;
	}

	if((hWnd = CreateWindow(
		APP_NAME,TEXT(__FILE__),
		(WS_OVERLAPPEDWINDOW ^ WS_THICKFRAME ^ WS_MAXIMIZEBOX) | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,
		(XSIZE*PIXEL_SIZE)+4,(YSIZE*PIXEL_SIZE)+30,
		NULL,NULL,hInstance,NULL)) == NULL){
		return 0;
	}

	while(GetMessage(&msg,NULL,0,0) > 0){
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

int fputBYTE(BYTE c,HANDLE hFile){
	int lpNumberOfBytesWritten;

	return WriteFile(hFile,&c ,sizeof(BYTE),&lpNumberOfBytesWritten,NULL);
}

int fputDWORD(DWORD c,HANDLE hFile){
	int lpNumberOfBytesWritten;

	return WriteFile(hFile,&c ,sizeof(DWORD),&lpNumberOfBytesWritten,NULL);
}

int fputWORD(WORD c,HANDLE hFile){
	int lpNumberOfBytesWritten;

	return WriteFile(hFile,&c ,sizeof(WORD),&lpNumberOfBytesWritten,NULL);
}

int saveImage(char *fileName){
	int x,y,z;
	DWORD color;

	// 萔ݒ
	int rem   = 3 * PWIDTH % 4;  // rbg[
	int dsize = rem > 0 ? 4 - rem : 0; // _~[TCY
	int isize = (3 * PWIDTH + dsize) * PHEIGHT; // 摜f[^TCY
	int fsize = 14 + 40 + isize;              // t@CTCY
	// t@C̃I[v
	HANDLE fp = CreateFile(fileName ,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

	if (fp == INVALID_HANDLE_VALUE) {
		MessageBox(NULL , TEXT("t@CJ܂") , NULL , MB_OK);
		return -1;
	}

	// BITMAP FILE HEADER (14byte)
	fputBYTE('B',fp); // t@Cʎq 'B'
	fputBYTE('M',fp); // t@Cʎq 'M'
	fputDWORD(fsize, fp); // t@CTCY
	fputWORD(0, fp); // \̈P
	fputWORD(0, fp); // \̈Q
	fputDWORD(14+40, fp); // f[^ItZbgiwb_TCYj

	// BITMAP INFO HEADER (40byte)
	fputDWORD(40, fp); // wb_TCY
	fputDWORD(PWIDTH, fp); // 摜TCY
	fputDWORD(PHEIGHT, fp); // 摜TCY
	fputWORD(1,fp); // v[
	fputWORD(24,fp); // Frbg
	fputDWORD(0,fp); // k
	fputDWORD(isize,fp); // 摜f[^TCY
	fputDWORD(0,fp); // 𑜓x
	fputDWORD(0,fp); // 𑜓x
	fputDWORD(0,fp); // gpF
	fputDWORD(0,fp); // dvF

	// sNZf[^̕ۑA摜̍ۑJn
	WaitForSingleObject(hMutex,INFINITE);
	for(y=PHEIGHT-1;y>= 0;y--){
		for(x=0;x<PWIDTH;x++){
			color = GetPixel(hMemDC,x,y);
			fputBYTE(GetBValue(color),fp);
			fputBYTE(GetGValue(color),fp);
			fputBYTE(GetRValue(color),fp);

			// _~[f[^
			for(z=0;z<dsize;z++){
				fputBYTE('\0', fp);
			}
		}
	}
	ReleaseMutex(hMutex);

	// Ô߃t@Cobt@tbVďI
	return FlushFileBuffers(fp);
}

